;;; MVGUIDE
;;; Converts current model space viewport 
;;; limits into a polyline
;;===================================================================================
(defun C:MVGUIDE (/ prgmod)
	(setq prgmod (getmode '("TILEMODE" "CLAYER" "OSMODE")))
 	(setvar "OSMODE" 0)
 	(mvdoc)
 	(setmode prgmod)
	(alert sclstr)
	(princ)
);defun
;;===================================================================================
(defun mvdoc (/ curlay icnt vwctr usrent fl pt1 pt2 pt3 pt4 scl set1 vwnumb vwsize pxc xsz pyc ysz dx dy)
	
	(if (= (getvar "TILEMODE") 1)
		(progn
			(setvar "TILEMODE" 0)
	 		(command "PSPACE")
	 	);progn
	);if

	(if (= (getvar "CVPORT") 1) 
		(progn
	 		(setq fl T)
	   		(command "MSPACE")
	   		(getpoint "\nPick a viewport")
 		);progn
	);if

	(setq
  		vwctr (getvar "VIEWCTR")  	;centrepoint of viewport
	  	vwsize (getvar "VIEWSIZE") 	;height of viewport
	  	vwnumb (getvar "CVPORT")   	;no. of current viewport
	);setq

	(command "PSPACE")

	(setq
		set1 (ssget "X" '((0 . "VIEWPORT"))) 	;get selection set of viewports
		icnt -1
	);setq

	(while (and icnt (< (setq icnt (1+ icnt)) (sslength set1))) 
		(setq usrent (entget (ssname set1 icnt)))
		(if (= (dxf 69 usrent) vwnumb) (setq icnt nil))
	);while

	(setq          					
  		xsz (dxf 40 usrent) 
 	 	ysz (dxf 41 usrent)
 	 	scl (/ vwsize ysz) 
	  	sclstr (strcat   "Viewport Scale is 1:" (rtos scl 2 2))
 	 	pxc  (car vwctr)
 	 	pyc  (cadr vwctr)
 	 	dx  (* xsz scl 0.5)
 		dy  (* ysz scl 0.5)
 	 	pt1 (list (- pxc dx) (- pyc dy))
 	 	pt2 (list (+ pxc dx) (- pyc dy))
  		pt3 (list (+ pxc dx) (+ pyc dy))
 	 	pt4 (list (- pxc dx) (+ pyc dy))
	);setq

	(command "MSPACE")
	(command "LAYER" "M" "DEFPOINTS" "")
	(command "PLINE" pt1 "W" 0 0 pt2 pt3 pt4 "C")

	(if (/= (dxf 8 usrent) "VIEWPORT") 
		(entmod (subst (cons 8 "VIEWPORT") (assoc 8 usrent) usrent))
	);if

	(if fl (command "PSPACE"))  			
);defun
;;===================================================================================
(defun getmode (mod1 / mod)
	(repeat (length mod1)
		(setq 
 			mod (append mod (list (list (car mod1) (getvar (car mod1)))))
			mod1 (cdr mod1)
		);setq
	);repeat
 	mod
);defun
;;===================================================================================
(defun setmode (mod1)
	(repeat (length mod1)
	  	(setvar (caar mod1) (cadar mod1))
  		(setq mod1 (cdr mod1))
 	);repeat
);defun
;;===================================================================================
(defun dxf (code elist) (cdr (assoc code elist)))
(princ)
